/*
 * This file was generated automatically by xsubpp version 1.9508 from the 
 * contents of easy.xs. Do not edit this file, edit easy.xs instead.
 *
 *	ANY CHANGES MADE HERE WILL BE LOST! 
 *
 */

#line 1 "easy.xs"
/*
 * Perl interface for libcurl. Check out the file README for more info.
 */

/*
 * Copyright (C) 2000, 2001, 2002 Daniel Stenberg, Cris Bailiff, et al.  
 * You may opt to use, copy, modify, merge, publish, distribute and/or 
 * sell copies of the Software, and permit persons to whom the 
 * Software is furnished to do so, under the terms of the MPL or
 * the MIT/X-derivate licenses. You may pick one of these licenses.
 */

#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include <curl/curl.h>
#include <curl/easy.h>

#if (LIBCURL_VERSION_NUM<0x070702)
#define CURLOPT_HEADERFUNCTION 20079
#define header_callback_func write_callback_func
#else
#define header_callback_func writeheader_callback_func
#endif

typedef enum {
    CALLBACK_WRITE = 0,
    CALLBACK_READ,
    CALLBACK_HEADER,
    CALLBACK_PROGRESS,
    CALLBACK_PASSWD,
    CALLBACK_LAST
} perl_curl_easy_callback_code;

typedef enum {
    SLIST_HTTPHEADER = 0,
    SLIST_QUOTE,
    SLIST_POSTQUOTE,
    SLIST_LAST
} perl_curl_easy_slist_code;

typedef struct {
    /* The main curl handle */
    struct CURL *curl;

    /* Lists that can be set via curl_easy_setopt() */
    struct curl_slist *slist[SLIST_LAST];
    SV *callback[CALLBACK_LAST];
    SV *callback_ctx[CALLBACK_LAST];

    /* copy of error buffer var for caller*/
    char errbuf[CURL_ERROR_SIZE+1];
    char *errbufvarname;

#ifdef WITH_INTERNAL_VARS
#define USE_INTERNAL_VARS 0x01
    /* Internal content storing */
    char *contbuf;
    char *bufptr;
    size_t bufsize;
    size_t contlen;
    int internal_options;
#endif

} perl_curl_easy;

/* switch from curl option codes to the relevant callback index */
static perl_curl_easy_callback_code callback_index(int option) {
    switch(option) {
	case CURLOPT_WRITEFUNCTION:
	case CURLOPT_FILE:
	    return CALLBACK_WRITE;
	    break;

	case CURLOPT_READFUNCTION:
	case CURLOPT_INFILE:
	    return CALLBACK_READ;
	    break;

	case CURLOPT_HEADERFUNCTION:
	case CURLOPT_WRITEHEADER:
	    return CALLBACK_HEADER;
	    break;

	case CURLOPT_PROGRESSFUNCTION:
	case CURLOPT_PROGRESSDATA:
	    return CALLBACK_PROGRESS;
	    break;

	case CURLOPT_PASSWDFUNCTION:
	case CURLOPT_PASSWDDATA:
	    return CALLBACK_PASSWD;
	    break;
    }
    croak("Bad callback index requested\n");
    return CALLBACK_LAST;
}

/* switch from curl slist names to an slist index */
static perl_curl_easy_slist_code slist_index(int option) {
    switch(option) {
	case CURLOPT_HTTPHEADER:
	    return SLIST_HTTPHEADER;
	    break;
	case CURLOPT_QUOTE:
	    return SLIST_QUOTE;
	    break;
	case CURLOPT_POSTQUOTE:
	    return SLIST_POSTQUOTE;
	    break;
    }
    croak("Bad slist index requested\n");
    return SLIST_LAST;
}

/* Setup these global vars */
static perl_curl_easy * perl_curl_easy_new()
{
    perl_curl_easy *self;
    Newz(1, self, 1, perl_curl_easy);
    if (!self)
	croak("out of memory");
    self->curl=curl_easy_init();
    return self;
}

static void perl_curl_easy_delete(perl_curl_easy *self)
{
    perl_curl_easy_slist_code index;
    if (self->curl) 
        curl_easy_cleanup(self->curl);

    for (index=0;index<SLIST_LAST;index++) {
	if (self->slist[index]) curl_slist_free_all(self->slist[index]);
    };

    if (self->errbufvarname) free(self->errbufvarname);

#ifdef WITH_INTERNAL_VARS
    if (self->contbuf) free(self->contbuf);
    self->bufptr = self->contbuf = NULL;
#endif

    Safefree(self);

}

/* Register a callback function */

static void perl_curl_easy_register_callback(perl_curl_easy *self, SV **callback, SV *function)
{
    /* FIXME: need to check the ref-counts here */
    if (*callback == NULL) {
	*callback = newSVsv(function);
    } else {
	SvSetSV(*callback, function);
    }
}

/* generic fwrite callback, which decides which callback to call */
static size_t
fwrite_wrapper (const void *ptr,
		size_t size,
		size_t nmemb,
		perl_curl_easy *self,
		void *call_function,
		void *call_ctx)
{
    dSP;

    if (call_function) { /* We are doing a callback to perl */
	int count, status;
	SV *sv;

	ENTER;
	SAVETMPS;

	PUSHMARK(SP);

	if (ptr) {
	    XPUSHs(sv_2mortal(newSVpvn((char *)ptr, (STRLEN)(size * nmemb))));
	} else { /* just in case */
	    XPUSHs(&PL_sv_undef);
	}

	if (call_ctx) {
	    XPUSHs(sv_2mortal(newSVsv(call_ctx)));
        } else { /* should be a stdio glob ? */
	    XPUSHs(&PL_sv_undef);
	}

	PUTBACK;
	count = perl_call_sv((SV *) call_function, G_SCALAR);
	SPAGAIN;

	if (count != 1)
            croak("callback for CURLOPT_WRITEFUNCTION didn't return a status\n");

	status = POPi;

	PUTBACK;
	FREETMPS;
	LEAVE;
	return status;

    } else {
	/* perform write directly, via PerlIO */

	PerlIO *handle;
	if (call_ctx) { /* Assume the context is a GLOB */
	    handle = IoOFP(sv_2io(call_ctx));
	} else { /* punt to stdout */
	    handle = PerlIO_stdout();
	}
	return PerlIO_write(handle,ptr,size*nmemb);
    }
}

/* Write callback for calling a perl callback */
size_t
write_callback_func( const void *ptr, size_t size, size_t nmemb, void *stream)
{
    perl_curl_easy *self;
    self=(perl_curl_easy *)stream;
    return fwrite_wrapper(ptr,size,nmemb,self,
        self->callback[CALLBACK_WRITE],self->callback_ctx[CALLBACK_WRITE]);
}

/* header callback for calling a perl callback */
size_t
writeheader_callback_func(const void *ptr, size_t size, size_t nmemb, void *stream)
{
    perl_curl_easy *self;
    self=(perl_curl_easy *)stream;

    return fwrite_wrapper(ptr,size,nmemb,self,
        self->callback[CALLBACK_HEADER],self->callback_ctx[CALLBACK_HEADER]);
}

/* read callback for calling a perl callback */
size_t
read_callback_func( void *ptr, size_t size, size_t nmemb, void *stream)
{
    dSP ;

    size_t maxlen;
    perl_curl_easy *self;
    self=(perl_curl_easy *)stream;

    maxlen = size*nmemb;

    if (self->callback[CALLBACK_READ]) { /* We are doing a callback to perl */
	char *data;
	int count;
	SV *sv;
	STRLEN len;

        ENTER ;
        SAVETMPS ;
 
        PUSHMARK(SP) ;

	if (self->callback_ctx[CALLBACK_READ]) {
            sv = self->callback_ctx[CALLBACK_READ];
        } else {
            sv = &PL_sv_undef;
        }
	
        XPUSHs(sv_2mortal(newSViv(maxlen)));
        XPUSHs(sv_2mortal(newSVsv(sv)));

        PUTBACK ;
        count = perl_call_sv(self->callback[CALLBACK_READ], G_SCALAR);
        SPAGAIN;

        if (count != 1)
            croak("callback for CURLOPT_READFUNCTION didn't return any data\n");

        sv = POPs;
        data = SvPV(sv,len);

        /* only allowed to return the number of bytes asked for */
        len = (len<maxlen ? len : maxlen);
        /* memcpy(ptr,data,(size_t)len); */
        Copy(data,ptr,len,char);

        PUTBACK ;
        FREETMPS ;
        LEAVE ;
        return (size_t) (len/size);

    } else {
	/* read input directly */
	PerlIO *f;
	if (self->callback_ctx[CALLBACK_READ]) { /* hope its a GLOB! */
	    f = IoIFP(sv_2io(self->callback_ctx[CALLBACK_READ]));
	} else { /* punt to stdin */
	    f = PerlIO_stdin();
	}
	return PerlIO_read(f,ptr,maxlen);
    }
}

/* Progress callback for calling a perl callback */

static int progress_callback_func(void *clientp, double dltotal, double dlnow,
    double ultotal, double ulnow)
{
    dSP;

    int count;
    perl_curl_easy *self;
    self=(perl_curl_easy *)clientp;

    ENTER;
    SAVETMPS;
    PUSHMARK(sp);
    if (self->callback_ctx[CALLBACK_PROGRESS]) {
	XPUSHs(sv_2mortal(newSVsv(self->callback_ctx[CALLBACK_PROGRESS])));
    } else {
	XPUSHs(&PL_sv_undef);
    }
    XPUSHs(sv_2mortal(newSVnv(dltotal)));
    XPUSHs(sv_2mortal(newSVnv(dlnow)));
    XPUSHs(sv_2mortal(newSVnv(ultotal)));
    XPUSHs(sv_2mortal(newSVnv(ulnow)));
    
    PUTBACK;
    count = perl_call_sv(self->callback[CALLBACK_PROGRESS], G_SCALAR);
    SPAGAIN;

    if (count != 1)
	croak("callback for CURLOPT_PROGRESSFUNCTION didn't return 1\n");

    count = POPi;

    PUTBACK;
    FREETMPS;
    LEAVE;
    return count;
}


/* Password callback for calling a perl callback */

static int passwd_callback_func(void *clientp, char *prompt, char *buffer, int buflen)
{
    dSP;
    char *data;
    SV *sv;
    STRLEN len;
    int count;

    perl_curl_easy *self;
    self=(perl_curl_easy *)clientp;

    ENTER;
    SAVETMPS;
    PUSHMARK(sp);
    if (self->callback_ctx[CALLBACK_PASSWD]) {
        XPUSHs(sv_2mortal(newSVsv(self->callback_ctx[CALLBACK_PASSWD])));
    } else {
	XPUSHs(&PL_sv_undef);
    }
    XPUSHs(sv_2mortal(newSVpv(prompt, 0)));
    XPUSHs(sv_2mortal(newSViv(buflen)));
    PUTBACK;
    count = perl_call_sv(self->callback[CALLBACK_PASSWD], G_ARRAY);
    SPAGAIN;
    if (count != 2)
	croak("callback for CURLOPT_PASSWDFUNCTION didn't return status + data\n");

    sv = POPs;
    count = POPi;

    data = SvPV(sv,len);
 
    /* only allowed to return the number of bytes asked for */
    len = (len<(buflen-1) ? len : (buflen-1));
    memcpy(buffer,data,len);
    buffer[buflen]=0; /* ensure C string terminates */

    PUTBACK;
    FREETMPS;
    LEAVE;
    return count;
}


#if 0
/* awaiting closepolicy prototype */
int 
closepolicy_callback_func(void *clientp)
{
   dSP;
   int argc, status;
   SV *pl_status;

   ENTER;
   SAVETMPS;

   PUSHMARK(SP);
   PUTBACK;

   argc = perl_call_sv(closepolicy_callback, G_SCALAR);
   SPAGAIN;

   if (argc != 1) {
      croak("Unexpected number of arguments returned from closefunction callback\n");
   }
   pl_status = POPs;
   status = SvTRUE(pl_status) ? 0 : 1;

   PUTBACK;
   FREETMPS;
   LEAVE;

   return status;
}
#endif


/* FIXME: should do this in the perl layer */
/* Internal write callback. Only used if USE_INTERNAL_VARS was specified */

#ifdef WITH_INTERNAL_VARS
static size_t internal_write_callback(const void *ptr, size_t size, size_t num, void *stream)
{
    perl_curl_easy *self;
    self=(perl_curl_easy *)stream;
   
    size *= num;
    if ((self->contlen + size) >= self->bufsize) {
	if (self->bufsize) {
	    self->bufsize *= 2; /* grow */
	} else {
	    self->bufsize = 32768; /* initial size */
	}
	self->contbuf = realloc(self->contbuf, self->bufsize + 1);
	self->bufptr = self->contbuf + self->contlen;
    }
    self->contlen += size;
    memcpy(self->bufptr, ptr, size);
    self->bufptr += size;
    *(self->bufptr) = '\0';
    return size;
}
#endif

#include "curlopt-constants.c"

typedef perl_curl_easy * Curl__easy;

#line 465 "easy.c"
XS(XS_Curl__easy_constant)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: Curl::easy::constant(name, arg)");
    {
	char *	name = (char *)SvPV(ST(0),PL_na);
	int	arg = (int)SvIV(ST(1));
	int	RETVAL;
	dXSTARG;

	RETVAL = constant(name, arg);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Curl__easy_init)
{
    dXSARGS;
    dXSI32;
    SP -= items;
    {
#line 474 "easy.xs"
	perl_curl_easy *self;
	char *sclass = "Curl::easy";
#line 492 "easy.c"
#line 477 "easy.xs"
    	if (items>0 && !SvROK(ST(0))) {
	    STRLEN dummy;
	    sclass = SvPV(ST(0),dummy);
	}

	self=perl_curl_easy_new(); /* curl handle created by this point */

	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), sclass, (void*)self);
	SvREADONLY_on(SvRV(ST(0)));

	/* configure curl to always callback to the XS interface layer */
	curl_easy_setopt(self->curl, CURLOPT_WRITEFUNCTION, write_callback_func);
	curl_easy_setopt(self->curl, CURLOPT_READFUNCTION, read_callback_func);
	curl_easy_setopt(self->curl, CURLOPT_HEADERFUNCTION, header_callback_func);
	curl_easy_setopt(self->curl, CURLOPT_PROGRESSFUNCTION, progress_callback_func);
	curl_easy_setopt(self->curl, CURLOPT_PASSWDFUNCTION, passwd_callback_func);

	/* set our own object as the context for all curl callbacks */
	curl_easy_setopt(self->curl, CURLOPT_FILE, self); 
	curl_easy_setopt(self->curl, CURLOPT_INFILE, self); 
	curl_easy_setopt(self->curl, CURLOPT_WRITEHEADER, self); 
	curl_easy_setopt(self->curl, CURLOPT_PROGRESSDATA, self); 
	curl_easy_setopt(self->curl, CURLOPT_PASSWDDATA, self); 

	/* we always collect this, in case it's wanted */
	curl_easy_setopt(self->curl, CURLOPT_ERRORBUFFER, self->errbuf);

	XSRETURN(1);
#line 523 "easy.c"
	PUTBACK;
	return;
    }
}

XS(XS_Curl__easy_version)
{
    dXSARGS;
    {
	char *	RETVAL;
	dXSTARG;
#line 510 "easy.xs"
	RETVAL=curl_version();
#line 537 "easy.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}

XS(XS_Curl__easy_setopt)
{
    dXSARGS;
    if (items != 3)
	Perl_croak(aTHX_ "Usage: Curl::easy::setopt(self, option, value)");
    {
	Curl__easy	self;
	int	option = (int)SvIV(ST(1));
	SV *	value = ST(2);
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "Curl::easy")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Curl__easy,tmp);
	}
	else
	    croak("self is not of type Curl::easy");
#line 520 "easy.xs"
	RETVAL=CURLE_OK;
	switch(option) {
	/* SV * to user contexts for callbacks - any SV (glob,scalar,ref) */
	case CURLOPT_FILE:
	case CURLOPT_INFILE:
	case CURLOPT_WRITEHEADER:
	case CURLOPT_PROGRESSDATA:
	case CURLOPT_PASSWDDATA:
	    perl_curl_easy_register_callback(self,&(self->callback_ctx[callback_index(option)]),value);
	    break;

	/* SV * to a subroutine ref */
	case CURLOPT_WRITEFUNCTION:
	case CURLOPT_READFUNCTION:
        case CURLOPT_HEADERFUNCTION:
	case CURLOPT_PROGRESSFUNCTION:
	case CURLOPT_PASSWDFUNCTION:
	    perl_curl_easy_register_callback(self,&(self->callback[callback_index(option)]),value);
	    break;

	/* slist cases */
	case CURLOPT_HTTPHEADER:
	case CURLOPT_QUOTE:
	case CURLOPT_POSTQUOTE:
	    {
		/* This is an option specifying a list, which we put in a curl_slist struct */
		AV *array = (AV *)SvRV(value);
		struct curl_slist **slist = NULL;
		int last = av_len(array);
		int i;

		/* We have to find out which list to use... */
		slist = &(self->slist[slist_index(option)]);

		/* free any previous list */
		if (*slist) {
		    curl_slist_free_all(*slist);
		    *slist=NULL;
		}                                                                       
		/* copy perl values into this slist */
		for (i=0;i<=last;i++) {
		    SV **sv = av_fetch(array,i,0);
		    int len = 0;
		    char *string = SvPV(*sv, len);
		    if (len == 0) /* FIXME: is this correct? */
			break;
		    *slist = curl_slist_append(*slist, string);
		}
		/* pass the list into curl_easy_setopt() */
		RETVAL = curl_easy_setopt(self->curl, option, *slist);
	    };
	    break;

	/* Pass in variable name for storing error messages. Yuck. */
	case CURLOPT_ERRORBUFFER:
	    {
		STRLEN dummy;
		if (self->errbufvarname) free(self->errbufvarname);
		self->errbufvarname = strdup((char *)SvPV(value, dummy));
	    };
	    break;

        /* tell curl to redirect STDERR - value should be a glob */
	case CURLOPT_STDERR:
	    RETVAL = curl_easy_setopt(self->curl, option, IoOFP(sv_2io(value)) );
	    break;

	/* default cases */
	default:
	    if (option < CURLOPTTYPE_OBJECTPOINT) { /* An integer value: */
		RETVAL = curl_easy_setopt(self->curl, option, (long)SvIV(value));
	    } else { /* A char * value: */
		/* FIXME: Does curl really want NULL for empty stings? */
		STRLEN dummy;
		char *pv = SvPV(value, dummy);
		RETVAL = curl_easy_setopt(self->curl, option, *pv ? pv : NULL);
	    };
	    break;
	};
#line 641 "easy.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Curl__easy_internal_setopt)
{
    dXSARGS;
    if (items != 3)
	Perl_croak(aTHX_ "Usage: Curl::easy::internal_setopt(self, option, value)");
    {
	Curl__easy	self;
	int	option = (int)SvIV(ST(1));
	int	value = (int)SvIV(ST(2));
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "Curl::easy")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Curl__easy,tmp);
	}
	else
	    croak("self is not of type Curl::easy");
#line 608 "easy.xs"
#ifdef WITH_INTERNAL_VARS
	if (value == 1) {
	    self->internal_options |= option;
	} else {
	    self->internal_options &= !option;
	}
#else
	croak("internal_setopt deprecated - recompile with -DWITH_INTERNAL_VARS for support\n");
#endif
	RETVAL = 0;
#line 676 "easy.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Curl__easy_perform)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Curl::easy::perform(self)");
    {
	Curl__easy	self;
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "Curl::easy")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Curl__easy,tmp);
	}
	else
	    croak("self is not of type Curl::easy");
#line 625 "easy.xs"
	/* perform the actual curl fetch */
#ifdef WITH_INTERNAL_VARS
	if (self->internal_options & USE_INTERNAL_VARS) {
	    /* Use internal callback which just stores the content into a buffer. */
	    self->bufptr = self->contbuf;
	    self->contlen = 0;
	    curl_easy_setopt(self->curl, CURLOPT_WRITEFUNCTION, internal_write_callback);
	    curl_easy_setopt(self->curl, CURLOPT_HEADER, 1);
	}
#endif
	RETVAL = curl_easy_perform(self->curl);

	if (RETVAL && self->errbufvarname) {
	    /* If an error occurred and a varname for error messages has been
	       specified, store the error message. */
	    SV *sv = perl_get_sv(self->errbufvarname, TRUE | GV_ADDMULTI);
	    sv_setpv(sv, self->errbuf);
	}
	/* Better to use plain perl for this - should work, but I have no scripts
	 * using this to test with. */
#ifdef WITH_INTERNAL_VARS
	if ((!RETVAL || (RETVAL == CURLE_PARTIAL_FILE)) &&
	   (self->internal_options & USE_INTERNAL_VARS)) {
	    /* No error and internal variable for the content are to be used:
	       Split the data into headers and content and store them into
	       perl variables. */
	    /* Note these are globals, and therefore are not safe between handles
	     * or threads */
	    SV *head_sv = perl_get_sv("Curl::easy::headers", TRUE | GV_ADDMULTI);
	    SV *cont_sv = perl_get_sv("Curl::easy::content", TRUE | GV_ADDMULTI);
	    char *p = self->contbuf;
	    int nl = 0, found = 0;
	    while (p < self->bufptr) {
		if (nl && (*p == '\n' || *p == '\r')) {
		/* found empty line, end of headers */
		*p++ = '\0';
		sv_setpv(head_sv, self->contbuf);
		while (*p == '\n' || *p == '\r') {
			p++;
		}
		sv_setpvn(cont_sv, p, self->bufptr - p);
		found = 1;
		break;
		}
		nl = (*p == '\n');
		p++;
	    }
	    if (!found) {
		sv_setpv(head_sv, "");
		sv_setpvn(cont_sv, self->contbuf, self->contlen);
	    }
	}
	/* reset */
	self->bufptr = self->contbuf;
	self->contlen = 0;
#endif
#line 755 "easy.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Curl__easy_getinfo)
{
    dXSARGS;
    if (items < 2)
	Perl_croak(aTHX_ "Usage: Curl::easy::getinfo(self, option, ...)");
    {
	Curl__easy	self;
	int	option = (int)SvIV(ST(1));
	SV *	RETVAL;

	if (sv_derived_from(ST(0), "Curl::easy")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Curl__easy,tmp);
	}
	else
	    croak("self is not of type Curl::easy");
#line 690 "easy.xs"
	switch (option & CURLINFO_TYPEMASK) {
	    case CURLINFO_STRING:
	    {
		char * vchar;
		curl_easy_getinfo(self->curl, option, &vchar);
		RETVAL = newSVpv(vchar,0);
		break;
	    }
	    case CURLINFO_LONG:
	    {
		long vlong;
		curl_easy_getinfo(self->curl, option, &vlong);
		RETVAL = newSViv(vlong);
		break;
	    }
	    case CURLINFO_DOUBLE:
	    {
		double vdouble;
		curl_easy_getinfo(self->curl, option, &vdouble);
		RETVAL = newSVnv(vdouble);
		break;
	    }
	    default: {
		RETVAL = newSViv(CURLE_BAD_FUNCTION_ARGUMENT);
		break;
	    }
	}
	if (items > 2) 
	    sv_setsv(ST(2),RETVAL);
#line 807 "easy.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}

XS(XS_Curl__easy_errbuf)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Curl::easy::errbuf(self)");
    {
	Curl__easy	self;
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "Curl::easy")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Curl__easy,tmp);
	}
	else
	    croak("self is not of type Curl::easy");
#line 726 "easy.xs"
    	RETVAL = self->errbuf;
#line 832 "easy.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}

XS(XS_Curl__easy_cleanup)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Curl::easy::cleanup(self)");
    {
	Curl__easy	self;
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "Curl::easy")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Curl__easy,tmp);
	}
	else
	    croak("self is not of type Curl::easy");
#line 734 "easy.xs"
    	/* does nothing anymore - cleanup is automatic when a curl handle goes out of scope */
	RETVAL = 0;
#line 857 "easy.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Curl__easy_DESTROY)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Curl::easy::DESTROY(self)");
    {
	Curl__easy	self;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Curl__easy,tmp);
	}
	else
	    croak("self is not a reference");
#line 743 "easy.xs"
        perl_curl_easy_delete(self);
#line 879 "easy.c"
    }
    XSRETURN_EMPTY;
}

XS(XS_Curl__easy_global_cleanup)
{
    dXSARGS;
    if (items != 0)
	Perl_croak(aTHX_ "Usage: Curl::easy::global_cleanup()");
    {
#line 748 "easy.xs"
    curl_global_cleanup();
#line 892 "easy.c"
    }
    XSRETURN_EMPTY;
}

#ifdef __cplusplus
extern "C"
#endif
XS(boot_Curl__easy)
{
    dXSARGS;
    char* file = __FILE__;

    XS_VERSION_BOOTCHECK ;

    {
        CV * cv ;

        newXSproto("Curl::easy::constant", XS_Curl__easy_constant, file, "$$");
        cv = newXS("Curl::easy::init", XS_Curl__easy_init, file);
        XSANY.any_i32 = 0 ;
        sv_setpv((SV*)cv, ";@") ;
        cv = newXS("Curl::easy::new", XS_Curl__easy_init, file);
        XSANY.any_i32 = 1 ;
        sv_setpv((SV*)cv, ";@") ;
        newXSproto("Curl::easy::version", XS_Curl__easy_version, file, ";@");
        newXSproto("Curl::easy::setopt", XS_Curl__easy_setopt, file, "$$$");
        newXSproto("Curl::easy::internal_setopt", XS_Curl__easy_internal_setopt, file, "$$$");
        newXSproto("Curl::easy::perform", XS_Curl__easy_perform, file, "$");
        newXSproto("Curl::easy::getinfo", XS_Curl__easy_getinfo, file, "$$;@");
        newXSproto("Curl::easy::errbuf", XS_Curl__easy_errbuf, file, "$");
        newXSproto("Curl::easy::cleanup", XS_Curl__easy_cleanup, file, "$");
        newXSproto("Curl::easy::DESTROY", XS_Curl__easy_DESTROY, file, "$");
        newXSproto("Curl::easy::global_cleanup", XS_Curl__easy_global_cleanup, file, "");
    }

    /* Initialisation Section */

#line 458 "easy.xs"
        curl_global_init(CURL_GLOBAL_ALL); /* FIXME: does this need a mutex for ithreads? */

#line 933 "easy.c"

    /* End of Initialisation Section */

    XSRETURN_YES;
}

